# integrates MASI lif signal, plots profiles
setwd("M:\\Niall")
source("savitzky golay.R")
source('M:/Niall/M026_scan_MASI_data_with_bg_correction.R')
source('M:/Niall/A448_get_MASI_profile.R')
current_directory="Y:\\Documents\\Groups\\JMCP\\MASI\\Data\\MASI-180221"
setwd(current_directory)
isos_files<-list.files(pattern="*processed.csv")
#write.table(isos_files,"file_list.txt",sep="\t",col.names = NA) 
num_files=length(isos_files)


file_list=rep(0,num_files)


n=0
#par(mai=c( 0, 0, 0, 0),oma=c(5,5,2,2),lwd=2,cex=1.5,mfrow=c(5,2))
pdf("M031_multiplot_c.pdf")
integ_m2=rep(0,num_files)
integ_na=rep(0,num_files)

meas_key=scan("meas_key.txt",what="char",sep="\t")
meas_index=as.numeric(scan("meas_index.txt",what="char",sep="\t"))
for(j in 1:num_files){
    if(meas_index[j]!=0){
        
        filename=isos_files[j]
        leng=nchar(filename)
        filename_original <- paste(substr(filename,1,leng-14),".csv",sep="")
        raw_data_original <- scan_MASI_data(current_directory,filename_original)
        raw_data <- scan_MASI_data(current_directory,filename)
        metal2 <- raw_data_original[,2]
        sodium <- raw_data[,1] 
        
        bkgnd_file <- isos_files[meas_index[j]]
        bkgnd_data <- scan_MASI_data(current_directory,bkgnd_file)
        sodium_bkgnd <- bkgnd_data[,1]
        bkgnd_file_original <- paste(substr(bkgnd_file,1,leng-14),".csv",sep="")
        bkgnd_original <- scan_MASI_data(current_directory,bkgnd_file_original)
        metal2_bkgnd <- bkgnd_original[,2]
        
        time_na=seq(1,length(sodium))*.1
        time_m2=seq(1,length(metal2))*.004
        
        measured_T=raw_data[,4]
        measured_T_original=raw_data_original[,4]
        scaling_na=1500/max(sodium) # so that sodium signal fits on temperature scale.
        scaling_M2=1500/max(metal2)
        if(max(sodium)>max(metal2)){
            sodium.scaled=sodium*scaling_na+1273 # because lowest temperature is 1273
            metal2.scaled=metal2*scaling_na+1273 # scale iron with sodium
            
        }
        if(max(sodium)<max(metal2)){
            sodium.scaled=sodium*scaling_M2+1273 # because lowest temperature is 1273
            metal2.scaled=metal2*scaling_M2+1273  # scale iron with sodium
            
        }
        
        cumulative<-rep(0,length(metal2))
        for(k in 1:length(metal2)){
            cumulative[k]<-sum(metal2[1:k])
        }
        cumulative.scaled<-cumulative/max(cumulative)*1000+1500
        bkgnd_cumulative<-rep(0,length(metal2))
        for(k in 1:length(metal2_bkgnd)){
            bkgnd_cumulative[k]<-sum(metal2_bkgnd[1:k])
        }
        bkgnd.cumulative.scaled<-bkgnd_cumulative/max(cumulative)*1000+1500
        metal2.scaled.smoothed<-sav.gol(metal2.scaled,151)
        
        plot(1,1,type='n',xlim=c(0,12),ylim=c(1200,2800),lwd=2)
        points(time_m2,metal2.scaled,type='l',col='black',lwd=1) 
        points(time_na,sodium.scaled,type='l',col='#FFBB00',lwd=1) 
        
        #    points(target_T[start:finish]-extra,alt_eq,type='l', col="#009900",lwd=2)
        points(time_na,measured_T,type='l',col='red',lwd=2,lty=2)
        points(time_m2,cumulative.scaled,type='l',col='green')  
        points(time_m2,bkgnd.cumulative.scaled,type='l',col='magenta')
        points(time_m2,metal2.scaled.smoothed,type='l',col='blue')  
        #   points(c(time[time_1650],time[time_1650]),c(1400,2700),type="l",col='#00BB00',lty=2,lwd=2)
        
        if(length(metal2)>2500){ # i.e. is a slow ramp
            integ_m2[j] <- sum(metal2[500:2250]) - sum(metal2_bkgnd[500:2250])
            integ_na[j] <- sum(sodium[20:90]) - sum(sodium_bkgnd[20:90])
        } else { # assumed to be an 8 second atmospheric profile
            hot_points_m2<-which(measured_T_original[200:1900]>1500)+200
            hot_points_na<-which(measured_T[8:76]>1500)+8
            if(max(measured_T[8:76])<1500){
                hot_points_m2<-which(measured_T_original[200:1900]>1400)+200
                hot_points_na<-which(measured_T[8:76]>1400)+8           
            }
            integ_m2[j] <- sum(metal2[hot_points_m2]) - sum(metal2_bkgnd[hot_points_m2])
            integ_na[j] <- sum(sodium[hot_points_na]) - sum(sodium_bkgnd[hot_points_na])
        }
        
        expt_lab=substr(filename,17,24)
        text(1,2700, expt_lab,cex=.7,pos=4)
        text(1,2600, integ_m2[j],cex=.7,pos=4)
        text(1,2500, j,cex=.7,pos=4)
        
    }
}
dev.off()

frac_ablated_na<-rep(0,num_files)
frac_ablated_m2<-rep(0,num_files)
for(j in 1:num_files){
    if(meas_index[j]!=0){
        if(meas_key[j]=='x'){
            frac_ablated_m2[j]<-integ_m2[j-1]/(integ_m2[j-1]+integ_m2[j])
            frac_ablated_na[j]<-integ_na[j-1]/(integ_na[j-1]+integ_na[j])
        }
    }
}
data_all<-cbind(integ_na,integ_m2,frac_ablated_na,frac_ablated_m2)
write.table(data_all,"M031_integrated_signal_c.txt",sep="\t") 

# 
# cumulative<-rep(0,length(metal2))
# for(k in 1:length(metal2)){
#     cumulative[k]<-sum(metal2[1:k])
# }
# plot(cumulative,type='l')