# Plots atmospheric profile for specific meteorite, size, velocity
# see rows 33 to 35
#
# base.dir<- "M:\\Niall"
# base.dir<- "C:\\Users\\David\\Documents\\Niall"
#filename = "MASI-2017-02-22_12-56-14.csv"
# update of A620, A709, M036, M092 for nickel

setwd(base.dir)
source("savitzky golay.R")
source('M026_scan_MASI_data_with_bg_correction.R')


A=scan("M170_DAC_values_for_atmospheric_profile_plots_allende.txt",what="char",sep="\t")
B= as.numeric(A[21:length(A)])
C<-matrix(B,10,length(B)/10)
DAC_values=t(C)

A=scan("M121_atmospheric_profile_key_NiMgCaFe.txt",what="char",sep="\t")
B=matrix(A,8,length(A)/8)
D=t(B)
directories = D[,2]
isos_index = as.numeric(D[,3])
velocities = as.numeric(D[,5])
sizes = as.numeric(D[,6])
meteorites = D[,7]
metal_type <- D[,8]

mass_list_allende<-c('1Em2','6Em1','3Em0','1Ep1')# allende
mass_list_chergach <-c('1Em2','7Em1','4Em0','1Ep1')# chergach
#
colours <- c("#ffbb00fe","#00dd99fe","#ff7700fe","#009900fe","#00bbfffe","#0000ddfe","#000000fe","#444444fe",
             "#ffdd88fe","#88eeccfe","#88ddfffe","#888888fe")

curr_meteorite<-'allende'
curr_velocity<-21
curr_size <- 3

if(curr_meteorite=='chergach'){
    curr_mass=mass_list_chergach[curr_size]
} else {curr_mass=mass_list_allende[curr_size]}
officePC="C:\\Users\\chmdbo\\Documents\\reference\\JDCS\\Atmospheric profiles\\" 
#laptop="C:\\Users\\David\\Documents\\Niall\\JDCS ablation profiles with nickel\\Atmospheric profiles\\"
DAC_index=intersect(which(DAC_values[,1]==curr_size),which(DAC_values[,2]==curr_velocity))
next_dir=paste(officePC,curr_meteorite,"\\v", curr_velocity,sep="")
setwd(next_dir)
filename = paste("sza035v0",curr_velocity,"mass",curr_mass,"test_comp_",curr_meteorite,"v2.txt",sep="")
A=scan(filename,what="char",sep=",")
data=A
B=as.numeric(data)

C<-matrix(B,50,length(B)/50)
D2=t(C)
cabmod_Mg <- D2[3500:4400,9]
cabmod_Na <- D2[3500:4400,28]
cabmod_Fe <- D2[3500:4400,12]+D2[3500:4400,46]
cabmod_Ca <- D2[3500:4400,15]
cabmod_AlO <- D2[3500:4400,19]
cabmod_Ni <- D2[3500:4400,48]
T_cabmod <- D2[3500:4400,4]
time_cabmod <-D2[3500:4400,2]
altitude_cabmod <- D2[3500:4400,1]

temp_matrix = matrix(0,3000,17)
time0_store = rep(0,17)

t1 = which(meteorites=='allende')
t2= which(sizes==curr_size)
t3 = which(velocities==curr_velocity)
t4=intersect(t1,t2)
curr_files=intersect(t4,t3)

temp_matrix = matrix(0,3000,length(curr_files))
time0_store = rep(0,length(curr_files))

for(j in 1:(length(curr_files))){
  
    curr_dir <- directories[curr_files[j]]
    current_directory=paste("Y:\\Documents\\Groups\\JMCP\\MASI\\Data\\",curr_dir,sep='')
    #current_directory=paste("C:\\Users\\David\\Documents\\Niall\\",curr_dir,sep='')
    setwd(current_directory)
    
    isos = list.files(pattern = ".csv")
    if(metal_type[curr_files[j]]=='Ni'|metal_type[curr_files[j]]=='Mg'){
    filename <- isos[2*isos_index[curr_files[j]]-1]
    } else {filename <- isos[isos_index[curr_files[j]]]}
    raw_data <- scan_MASI_data(current_directory,filename)
    
    MASI_temp <- raw_data[,4]
    temp_matrix[1:length(raw_data[,4]),j]<-MASI_temp
    
    T1900 <- which(abs(MASI_temp-1900)<10)
    T1900 <- T1900[1]
    time0 <- T1900*.004
    time0_store[j]<- time0

    
} 

time_expt <- raw_data[,3]

T1900_cabmod <- which(abs(T_cabmod-1900)<5)
T1900_cabmod <- T1900_cabmod[1]
time0_cabmod <- time_cabmod[T1900_cabmod]
time_cabmod_corr <- time_cabmod - time0_cabmod

Mg_all<-rep(0,3003)
Ca_all<-rep(0,3003)
Fe_all<-rep(0,3003)
Na_all<-rep(0,3003)
Ni_all<-rep(0,3003)


signal_matrix <- matrix(0,length(curr_files),3003)
Na_signal_matrix <- matrix(0,length(curr_files),3003)
T_profile_store <- matrix(0,length(curr_files),3003)
for(j in 1:length(curr_files)){
 
    curr_dir <- directories[curr_files[j]]
    current_directory=paste("Y:\\Documents\\Groups\\JMCP\\MASI\\Data\\",curr_dir,sep='')
    setwd(current_directory)
    
    time0 <- time0_store[j]
    time_start <- time0-1.5
    
    isos = list.files(pattern = ".csv")
    if(metal_type[curr_files[j]]=='Ni'|metal_type[curr_files[j]]=='Mg'){
        filename <- isos[2*isos_index[curr_files[j]]-1]
    } else {filename <- isos[isos_index[curr_files[j]]]}
    
    raw_data <- scan_MASI_data(current_directory,filename)
    time_expt <- raw_data[,3]
    metal2 <- raw_data[,2]
    time_corr <- time_expt - time0
    start_index <- which.min(abs(time_corr+1.5))
    length_altitude <- length(time_expt)-start_index+1
    altitude <- rep(0,length_altitude)
    for(k in 1:length_altitude){
        altitude[k] <- altitude_cabmod[which.min(abs(time_cabmod_corr-time_corr[k+start_index-1]))]/1000
    }
    
    smoothing_factor<- 25
    
    if(metal_type[curr_files[j]]=='Mg'){
        
        background_M2 <- mean(metal2[start_index:(start_index+125)])
        metal2_corr <- metal2[start_index:length(metal2)] - background_M2
        metal2_smoothed <- sav.gol(metal2_corr,smoothing_factor)
        scaling_M2=1/max(metal2_smoothed)
        metal2.scaled=metal2_smoothed*scaling_M2
        Mg_all <- Mg_all + metal2.scaled
        #points(metal2.scaled[1:length_altitude],altitude,type='l',col=colours[10],lwd=1) 
        
    } else if(metal_type[curr_files[j]]=='Ni'){
        background_M2 <- mean(metal2[start_index:(start_index+125)])
        metal2_corr <- metal2[start_index:length(metal2)] - background_M2
        metal2_smoothed <- sav.gol(metal2_corr,smoothing_factor)
        scaling_M2=1/max(metal2_smoothed)
        metal2.scaled=metal2_smoothed*scaling_M2
        Ni_all <- Ni_all + metal2.scaled
        #points(metal2.scaled[1:length_altitude],altitude,type='l',col=colours[10],lwd=1) 
        
    } else if(metal_type[curr_files[j]]=='Fe'){        
        sodium <- raw_data[,1]
        background_Na <- mean(sodium[start_index:(start_index+125)])
        sodium_corr <- sodium[start_index:length(metal2)]-background_Na
        sodium.smoothed <- sav.gol(sodium_corr,smoothing_factor)
        scaling_na=1/max(sodium.smoothed)
        sodium.scaled=sodium_corr*scaling_na
        Na_all <- Na_all + sodium.scaled  
        #  points(sodium.scaled[1:length_altitude],altitude,type='l',col=colours[9],lwd=1) 
        
        
        background_M2 <- mean(metal2[start_index:(start_index+125)])
        metal2_corr <- metal2[start_index:length(metal2)] - background_M2
        metal2_smoothed <- sav.gol(metal2_corr,smoothing_factor)
        scaling_M2=1/max(metal2_smoothed)
        metal2.scaled=metal2_smoothed*scaling_M2
        Fe_all <- Fe_all + metal2.scaled   
        Na_signal_matrix[j,1:length(sodium.scaled)]<-sodium.scaled
        # points(metal2.scaled[1:length_altitude],altitude,type='l',col=colours[12],lwd=1) 
        
    } else if(metal_type[curr_files[j]]=='Ca'){
        sodium <- raw_data[,1]
        background_Na <- mean(sodium[start_index:(start_index+125)])
        sodium_corr <- sodium[start_index:length(metal2)]-background_Na
        sodium.smoothed <- sav.gol(sodium_corr,25)
        scaling_na=1/max(sodium.smoothed)
        sodium.scaled=sodium_corr*scaling_na
        Na_all <- Na_all + sodium.scaled 
        #  points(sodium.scaled[1:length_altitude],altitude,type='l',col=colours[9],lwd=1)
        
        
        background_M2 <- mean(metal2[start_index:(start_index+125)])
        metal2_corr <- metal2[start_index:length(metal2)] - background_M2
        metal2_smoothed <- sav.gol(metal2_corr,smoothing_factor)
        scaling_M2=1/max(metal2_smoothed)
        metal2.scaled=metal2_smoothed*scaling_M2
        Ca_all <- Ca_all + metal2.scaled  
        Na_signal_matrix[j,1:length(sodium.scaled)]<-sodium.scaled
        # points(metal2.scaled[1:length_altitude],altitude,type='l',col=colours[11],lwd=1) 
        
        
    }
    signal_matrix[j,1:length(metal2.scaled)]<-metal2.scaled
    
    T_profile <- raw_data[start_index:length(metal2),4]
    T_profile_store[j,1:(length(T_profile))]<- T_profile
 
}

Mg_DAC = DAC_values[DAC_index,7]
Ca_DAC = DAC_values[DAC_index,5]
Fe_DAC = DAC_values[DAC_index,3]
Ni_DAC = DAC_values[DAC_index,9]

integ_Na=0
integ_Mg=0
integ_Fe=0
integ_Ca=0
integ_Ni=0
for(k in 200:800){
    integ_Na=integ_Na+(Na_all[k+1]+Na_all[k])/2*(altitude[k]-altitude[k+1])
    integ_Mg=integ_Mg+(Mg_all[k+1]+Mg_all[k])/2*(altitude[k]-altitude[k+1])
    integ_Fe=integ_Fe+(Fe_all[k+1]+Fe_all[k])/2*(altitude[k]-altitude[k+1])
    integ_Ca=integ_Ca+(Ca_all[k+1]+Ca_all[k])/2*(altitude[k]-altitude[k+1])
    integ_Ni=integ_Ni+(Ni_all[k+1]+Ni_all[k])/2*(altitude[k]-altitude[k+1])
    }

sodium.smoothed=Na_all/integ_Na*1/Fe_DAC
magnesium.smoothed=Mg_all/integ_Mg*Mg_DAC/Fe_DAC
iron.smoothed=Fe_all/integ_Fe*Fe_DAC/Fe_DAC
calcium.smoothed=Ca_all/integ_Ca*Ca_DAC/Fe_DAC
nickel.smoothed=Ni_all/integ_Ni*Ni_DAC/Fe_DAC

norm_factor<-sum(cabmod_Fe)/10

setwd(base.dir)
pdf(paste("M188_MASI_atmospheric_profile_Fe_",curr_meteorite,"_size",curr_size,"v",curr_velocity,"_CABMOD.pdf",sep=""),height = 8/2,width = 8/2)
xlabel=expression("Injection rate /a.u.")
plot(1,1,xlim=c(1e9,1e14),log="x",xaxt="n",type='n',ylim=c(75,107),lwd=2,ylab="Altitude /km",xlab=xlabel,tcl=-.2,labels=FALSE)
ticks <- seq(9, 14, by=1)
labels <- sapply(ticks, function(i) as.expression(bquote(10^ .(i))))
axis(1, at=10^ticks, labels=labels, tcl=-.2,padj=-0.8)

axis(2, tcl=-.2,padj=0.5,at=c(80,90,100))
mtext(xlabel,1,padj=1.4,cex=1)

calcium.smoothed[which(calcium.smoothed*norm_factor<1e7)]<- 0

points(sodium.smoothed[200:800]*norm_factor,altitude[200:800],type='l',col=colours[3],lwd=1.5) 
#points(magnesium.smoothed[300:620]*norm_factor,altitude[300:620],type='l',col=colours[4],lwd=1.5)
#points(calcium.smoothed[200:800]*norm_factor,altitude[200:800],type='l',col='blue',lwd=1.5)

points(nickel.smoothed[200:800]*norm_factor,altitude[200:800],type='l',col='brown',lwd=1.5)
points(iron.smoothed[250:800]*norm_factor,altitude[250:800],type='l',col=colours[7],lwd=1.5)
points(T_profile/2800,altitude,type='l',col='red',lwd=1.5)
#points(10^((T_profile-1273)/400+9.5),altitude,type='l',col='red',lwd=2)

points(10^((T_cabmod-1273)/400+9.5),altitude_cabmod/1000,type='l',col='red',lwd=2,lty=2)
#points(cabmod_Mg,altitude_cabmod/1000,type='l',col=colours[4],lwd=1.5,lty=2) 
#points(cabmod_Ca,altitude_cabmod/1000,type='l',col='blue',lwd=1.5,lty=2)
points(cabmod_Fe,altitude_cabmod/1000,type='l',col=colours[7],lwd=1.5,lty=2) 
#points(cabmod_Fe_old,altitude_cabmod/1000,type='l',col=colours[7],lwd=1.5,lty=3) 
points(cabmod_Ni,altitude_cabmod/1000,type='l',col='brown',lwd=1.5,lty=2) 
points(cabmod_Na,altitude_cabmod/1000,type='l',col=colours[3],lwd=1.5,lty=2) 
colours_plot <- c(colours[3],colours[7],'brown','red')


T_series <- c(1000,1500,2000,2500,3000)
T_tick_pos <- 10^((T_series-1273)/400+9.5)
axis(3, at=T_tick_pos, labels=T_series, xlab="Temperature /K",tcl=-0.2,padj=0.5)
xlabel = "Temperature /K" 

dev.off()


