# Colours - need to change yellow to something else. different line types
# need to renormalise averaged signal
# limit x tmax range to 2700 K
# label size
# legend
# change plot label ie allende size 3

base.dir = "M:\\Niall"
setwd(base.dir)
source('M026_scan_MASI_data_with_bg_correction.R')
source('A448_get_MASI_profile.R')
source('savitzky golay.R')

mass_allende<-c('1Em2','6Em1','3Em0','1Ep1','2Ep1')# allende
mass_chergach<-c('1Em2','7Em1','4Em0','1Ep1','3Ep1')# chergach

smoothing_factor<-151
# This file is an updated version of A649 without the calibration factor

A=scan('M113_M087_linear_ramp_key_all_Feb_Ni_MASI.txt',what='char')
B<-matrix(A,8,length(A)/8)
D=t(B)
meteorite<-D[,5]
num_files <- length(meteorite)
meteorite<-c(meteorite,"stop") # so the loop knows when its at the last file.
sizes<-D[,6]
sizes<-c(sizes,0) # so the loop knows when its at the last file.

isos_index <- as.numeric(D[,2])
directories <-  D[,4]

peak_time_Na <- as.numeric(D[,7])
peak_time_Ni <-  as.numeric(D[,8])

A=scan('M083_average_peak_times_linear_ramp_Ni_MASI.txt',what='char')
B<-as.numeric(A[8:length(A)])
C<-  matrix(B,6,length(B)/6)
D=t(C)
B2<-A[8:length(A)]
C2<-matrix(B2,6,length(B2)/6)
D2<-t(C2)
label<-D2[,1]
avg_peak_time_Na <- D[,3]
avg_peak_time_Ni <- D[,5]
unit_sd_peak_na = round(D[,4]*10)
unit_sd_peak_ni = round(D[,6]*250)
unit_na_peak = round(avg_peak_time_Na*10)
unit_ni_peak = round(avg_peak_time_Ni*250)

pdf("M115_linear_ramp_NaNi_signal_envelope.pdf")

par(mfrow=c(3,1),mai=c( 0, 0, 0, 0),oma=c(5,4,4,2),cex=2/3)
#oma controls outer margins, mai (or mar) controls margins between subplots
current_meteorite <- "none"
current_size <- "none"
averages_index <- 1
num_spectra<-0
na_sum_spectra<-rep(0,159) # 2 seconds added at each end
ni_sum_spectra<-rep(0,3999) # 2 seconds added at each end

ni_all_spectra<-matrix(0,3999,15)
na_all_spectra<-matrix(0,159,15)

diff_store<-NULL 
for(j in 1:num_files){
    num_spectra<-num_spectra+1    
    current_meteorite=meteorite[j]
    current_size<-sizes[j]
    
    time_Na_peak <- peak_time_Na[j]
    curr_avg_Na_time <- avg_peak_time_Na[averages_index]
    time_Ni_peak <- peak_time_Ni[j]
    curr_avg_Ni_time <- avg_peak_time_Ni[averages_index]
    # get data for current file
    current_directory=paste(base.dir,"/MASI-",directories[j],sep="")
    setwd(current_directory)
    isos_files<-list.files(pattern="*.csv")
    filename <- isos_files[(isos_index[j]*2)-1]
    raw_data <- scan_MASI_data(current_directory,filename)
    
    filename <- isos_files[(isos_index[j]*2)]
    raw_data_Na <- scan_MASI_data(current_directory,filename)
    
    sodium<-raw_data_Na[,1]
    
    metal2<-raw_data[,2]
    measured_T <- raw_data[,4]
    
    time_corrected <- seq(.004,11.996,by=.004) #- time_Ni_peak + curr_avg_Ni_time
    shift_ni<- curr_avg_Ni_time - time_Ni_peak
    if(time_Na_peak!=0){
        
        time_corrected_Na <- seq(.1,11.9,by=.1) #- time_Na_peak + curr_avg_Na_time
        shift_na<- curr_avg_Na_time - time_Na_peak
        
    } else {time_corrected_Na <- seq(.1,11.9,by=.1)
    shift_na<-0
    }
    
    time_T <- time_corrected*120+1270
    time_T_Na <- time_corrected_Na*120+1270
    
    metal2.smoothed<-sav.gol(metal2,smoothing_factor)
    sodium.scaled=sodium/max(sodium) 
    metal2.scaled=metal2.smoothed/max(metal2.smoothed)
   
    
    #text(1500,1,paste(meteorite[j],sizes[j]),pos=4)
    unit_shift_na=round(10*shift_na)
    na_start<-20+unit_shift_na
    na_finish<-na_start+118
    na_sum_spectra[na_start:na_finish]<-na_sum_spectra[na_start:na_finish]+sodium.scaled
    na_all_spectra[na_start:na_finish,num_spectra]<-sodium.scaled
    unit_shift_ni=round(250*shift_ni)
    ni_start<-500+unit_shift_ni
    ni_finish<-ni_start+2998
    ni_sum_spectra[ni_start:ni_finish]<-ni_sum_spectra[ni_start:ni_finish]+metal2.scaled
    ni_all_spectra[ni_start:ni_finish,num_spectra]<-metal2.scaled
    
    if((meteorite[j+1]!=current_meteorite)||(sizes[j+1]!=current_size)){
        setwd(paste("C:\\Users\\chmdbo\\Documents\\reference\\JDCS\\Linear_ramp_profiles\\",current_meteorite,sep=""))
        if(meteorite[j]=="allende"){
            curr_mass = mass_allende[as.numeric(sizes[j])]
        } else if(meteorite[j]=="chergach"){
            curr_mass = mass_chergach[as.numeric(sizes[j])]
        } else {curr_mass = 1}
        if((meteorite[j]=="chergach")|(meteorite[j]=="allende")){
            filename = paste("sza000V014mass",curr_mass,"test_comp_",current_meteorite,".txt",sep="")
        } else if((meteorite[j]=="ni-fe")){
            filename = "sza000v014mass3Em1test_comp_alloy.txt"
        } else if(meteorite[j]=="pentlandite"){
            filename = "sza000v014mass2Em2test_comp_pentlandite.txt"
        }
        
        A=scan(filename,what="char",sep=",")
        data=A
        B=as.numeric(data)
        
        C<-matrix(B,50,length(B)/50)
        D2=t(C)
        # length of cabmod profile is 3401 but measured profile stops at row 3027
        cabmod_start_index=which.min(abs(D2[,4]-1510))
        cabmod_finish_index=3027
        cabmod_Na <- D2[cabmod_start_index:cabmod_finish_index,28]
        
        cabmod_Ni <- D2[cabmod_start_index:cabmod_finish_index,48]
        T_cabmod <- D2[cabmod_start_index:cabmod_finish_index,4]
        time_cabmod <-D2[cabmod_start_index:cabmod_finish_index,2]
        
        false_point_index=1639-cabmod_start_index
       cabmod_Na = cabmod_Na[-false_point_index]
       cabmod_Ni = cabmod_Ni[-false_point_index]
       T_cabmod = T_cabmod[-false_point_index]
       time_cabmod = time_cabmod[-false_point_index]
        
        zero_index=which(time_cabmod==0)
        if(is.element(0,time_cabmod)){
        cabmod_Na = cabmod_Na[-zero_index]
        cabmod_Ni = cabmod_Ni[-zero_index]
        T_cabmod = T_cabmod[-zero_index]
        time_cabmod = time_cabmod[-zero_index]
        }
        plot(1,1,type='n',xlim=c(1500,2700),ylim=c(0,1.2),xlab="Temperature /K",
             ylab="normalised signal", cex.axis=2, xaxs='i') 
        # relevant part of Ni signal: indices 473-2973 (973-3473)
        # relevant part of Na signal: indices 19-119 (39-138)
        na_all_spectra[which(na_all_spectra< -0.048)]=-0.048
        ni_all_spectra[which(ni_all_spectra< -0.048)]=-0.048
        na_sum_spectra=na_sum_spectra/num_spectra
        ni_sum_spectra=ni_sum_spectra/num_spectra
        na_sum_spectra[which(na_sum_spectra< -0.048)]=NaN
        ni_sum_spectra[which(ni_sum_spectra< -0.048)]=NaN
        for(k in 1:num_spectra){
            if(time_Na_peak!=0){
                points(time_T_Na[20:118],na_all_spectra[40:138,k],type='l',col='tan1',lwd=1) 
            }
            points(time_T[498:2973],ni_all_spectra[998:3473,k],type='l',col='tan',lwd=1)            
        }
        if(j>1){ # ie not first spectrum
            time_T<-seq(.004,11.996,by=.004)*120+1270
            time_T_Na<-seq(.1,11.9,by=.1)*120+1270
            if(time_Na_peak!=0){
                points(time_T_Na[20:118],na_sum_spectra[40:138],type='l',col='#FF6600',lwd=2) 
            }
            points(time_T[498:2973],ni_sum_spectra[998:3473],type='l',col='brown',lwd=2) 
            
            
        }
        
        
        if(time_Na_peak!=0){
            points(T_cabmod,cabmod_Na/max(cabmod_Na),type='l',col='#FF6600',lwd=2,lty=2) 
            
        }
       
       points(T_cabmod,cabmod_Ni/max(cabmod_Ni),type='l',col='sienna4',lwd=2,lty=2) 
       
       # plotting error envelope
       sd_current_ni=rep(0,3999)
       mean_current_ni=rep(0,3999)
       sd_current_na=rep(0,159)
       mean_current_na=rep(0,159)
       envelope_lower_na=rep(0,159)
       envelope_upper_na=rep(0,159)
       envelope_lower_ni=rep(0,3999)
       envelope_upper_ni=rep(0,3999)
       for(k in 1:3999){
           sd_current_ni[k]<-sd(ni_all_spectra[k,1:num_spectra])
           mean_current_ni[k]<-mean(ni_all_spectra[k,1:num_spectra])
       }
       for(k in 1:159){
           sd_current_na[k]<-sd(na_all_spectra[k,1:num_spectra])
           mean_current_na[k]<-mean(na_all_spectra[k,1:num_spectra])
           
       }
       # na envelope
       if(time_Na_peak!=0){
       for(k in 20:138){
       envelope_upper_na[k] = max(c(mean_current_na[k]+sd_current_na[k],mean_current_na[k-unit_sd_peak_na[averages_index]],mean_current_na[k+unit_sd_peak_na[averages_index]])) 
       envelope_lower_na[k] = min(c(mean_current_na[k]-sd_current_na[k],mean_current_na[k-unit_sd_peak_na[averages_index]],mean_current_na[k+unit_sd_peak_na[averages_index]])) 
       }
       for(k in 20+(unit_na_peak[averages_index]-unit_sd_peak_na[averages_index]):(unit_na_peak[averages_index]+unit_sd_peak_na[averages_index])){
           envelope_upper_na[k] = 1
       }
       envelope_upper_na = sav.gol(envelope_upper_na,7)
       envelope_lower_na = sav.gol(envelope_lower_na,7)
       envelope_lower_na[which(envelope_lower_na< -0.048)]=-0.048
       envelope_upper_na[which(envelope_upper_na> 1)]=1
       points(time_T_Na[19:118],envelope_upper_na[39:138],type='l',col='blue')
       points(time_T_Na[19:118],envelope_lower_na[39:138],type='l',col='blue')
    }
       # ni envelope
       for(k in 500:3498){
           envelope_upper_ni[k] = max(c(mean_current_ni[k]+sd_current_ni[k],mean_current_ni[k-unit_sd_peak_ni[averages_index]],mean_current_ni[k+unit_sd_peak_ni[averages_index]])) 
           envelope_lower_ni[k] = min(c(mean_current_ni[k]-sd_current_ni[k],mean_current_ni[k-unit_sd_peak_ni[averages_index]],mean_current_ni[k+unit_sd_peak_ni[averages_index]])) 
       }
       for(k in 500+(unit_ni_peak[averages_index]-unit_sd_peak_ni[averages_index]):(unit_ni_peak[averages_index]+unit_sd_peak_ni[averages_index])){
           envelope_upper_ni[k] = 1
       }
       envelope_upper_ni = sav.gol(envelope_upper_ni,51)
       envelope_lower_ni = sav.gol(envelope_lower_ni,51)
       envelope_lower_ni[which(envelope_lower_ni< -0.048)]=-0.048
       envelope_upper_ni[which(envelope_upper_ni> 1)]=1
       points(time_T[473:2973],envelope_upper_ni[973:3473],type='l',col='darkgreen')
       points(time_T[473:2973],envelope_lower_ni[973:3473],type='l',col='darkgreen')       
       #points(time_T[473:2973],mean_current_ni[973:3473],type='l')
       # points(time_T,mean_current[500:3498]+sd_current[500:3498],type='l',col='red')
       # points(time_T,mean_current[500:3498]-sd_current[500:3498],type='l',col='red')
  if(averages_index==8){
            filename = "sza000v014mass2Ep1test_comp_pentlandite.txt"    
            A=scan(filename,what="char",sep=",")
            data=A
            B=as.numeric(data)
            
            C<-matrix(B,50,length(B)/50)
            D2=t(C)
            # length of cabmod profile is 3401 but measured profile stops at row 3027
            cabmod_start_index=which.min(abs(D2[,4]-1510))
            cabmod_finish_index=3027
            cabmod_Na <- D2[cabmod_start_index:cabmod_finish_index,28]
            
            cabmod_Ni <- D2[cabmod_start_index:cabmod_finish_index,48]
            T_cabmod <- D2[cabmod_start_index:cabmod_finish_index,4]
            time_cabmod <-D2[cabmod_start_index:cabmod_finish_index,2]
            
            false_point_index=1639-cabmod_start_index
            cabmod_Na = cabmod_Na[-false_point_index]
            cabmod_Ni = cabmod_Ni[-false_point_index]
            T_cabmod = T_cabmod[-false_point_index]
            time_cabmod = time_cabmod[-false_point_index]
            
            zero_index=which(time_cabmod==0)
            if(is.element(0,time_cabmod)){
                cabmod_Na = cabmod_Na[-zero_index]
                cabmod_Ni = cabmod_Ni[-zero_index]
                T_cabmod = T_cabmod[-zero_index]
                time_cabmod = time_cabmod[-zero_index]
            }     
            points(T_cabmod,cabmod_Ni/max(cabmod_Ni),type='l',col='red',lwd=2,lty=2) 
            
  }
       num_spectra<-0 #reset since next file is new size
       ni_all_spectra<-matrix(0,3999,15)
       na_all_spectra<-matrix(0,159,15)
       na_sum_spectra<-rep(0,159) # 2 seconds added at each end
       ni_sum_spectra<-rep(0,3999) # 2 seconds added at each end
       averages_index<-averages_index+1
    } 
    
}
#plot cabmod pentlandite large particle size case




dev.off()