# This file finds the centroid of each LIF profile, i.e. where %50 of the 
# ablation has occurred
setwd("D:\\Niall")
source("savitzky golay.R")
source('D:/Niall/M026_scan_MASI_data_with_bg_correction.R')
source('D:/Niall/A448_get_MASI_profile.R')
curr_dir<-"171023"


setwd("D:\\Niall")
A<-scan("M040_cabmod_times_chergach.txt",what="char",sep="\t")
B<-as.numeric(A[22:length(A)])
C<-matrix(B,21,4401)
times_chergach=t(C)
A<-scan("M040_cabmod_times_allende.txt",what="char",sep="\t")
B<-as.numeric(A[26:length(A)])
C<-matrix(B,25,4401)
times_allende=t(C)
A<-scan("M040_cabmod_temperatures_chergach.txt",what="char",sep="\t")
B<-as.numeric(A[26:length(A)])
C<-matrix(B,25,4401)
temperatures_chergach=t(C)
A<-scan("M040_cabmod_temperatures_allende.txt",what="char",sep="\t")
B<-as.numeric(A[26:length(A)])
C<-matrix(B,25,4401)
temperatures_allende=t(C)

current_directory=paste("D:\\MASI-",curr_dir,sep='')
setwd(current_directory)
isos_files<-list.files(pattern="*processed.csv")

num_files=length(isos_files)
file_list=rep(0,num_files)

percent_integrated<-50 # script refers to centroid but this is a more general case. For
# for centroid set this to 50
n=0

integ_m2=rep(0,num_files)
integ_na=rep(0,num_files)
centroid_time=rep(0,num_files)
centroid_time_cabmod<-rep(0,num_files)
centroid_temp=rep(0,num_files)
centroid_index=rep(0,num_files)
centroid_altitude=rep(0,num_files)
centroid_cabmod_index=rep(0,num_files)
altitude <- seq(500,60,by=-0.1)

meas_key=scan("meas_key.txt",what="char",sep="\t")
meas_index=as.numeric(scan("meas_index.txt",what="char",sep="\t"))
for(j in 1:num_files){
    if(meas_index[j]!=0){
        
        filename=isos_files[j]
        profile<-get_MASI_profile(current_directory, filename)
        leng=nchar(filename)
        filename_original <- paste(substr(filename,1,leng-14),".csv",sep="")
        raw_data_original <- scan_MASI_data(current_directory,filename_original)
        raw_data <- scan_MASI_data(current_directory,filename)
        metal2 <- raw_data_original[,2]
        sodium <- raw_data[,1] 
        
        bkgnd_file <- isos_files[meas_index[j]]
        bkgnd_data <- scan_MASI_data(current_directory,bkgnd_file)
        sodium_bkgnd <- bkgnd_data[,1]
        bkgnd_file_original <- paste(substr(bkgnd_file,1,leng-14),".csv",sep="")
        bkgnd_original <- scan_MASI_data(current_directory,bkgnd_file_original)
        metal2_bkgnd <- bkgnd_original[,2]
        
        time_na=seq(1,length(sodium))*.1
        time_m2=seq(1,length(metal2))*.004
        
        measured_T=raw_data[,4]
        measured_T_original=raw_data_original[,4]
        scaling_na=1500/max(sodium) # so that sodium signal fits on temperature scale.
        scaling_M2=1500/max(metal2)
        if(max(sodium)>max(metal2)){
            sodium.scaled=sodium*scaling_na+1273 # because lowest temperature is 1273
            metal2.scaled=metal2*scaling_na+1273 # scale nickel with sodium
            
        }
        if(max(sodium)<max(metal2)){
            sodium.scaled=sodium*scaling_M2+1273 # because lowest temperature is 1273
            metal2.scaled=metal2*scaling_M2+1273  # scale sodium with Ni
        }
        
        
        metal2.scaled.smoothed<-sav.gol(metal2.scaled,151)
        
        meteorite<-substr(profile,20,27)
        if(meteorite=='chergach'){
            sizebin=substr(profile,18,18) 
            velocity=substr(profile,15,16) 
            
            chergach_cols<-c("x","v14c1","v14c2","v14c3","v14c4","x","v17c1","v17c2","v17c3","v17c4","x","v21c1","v21c2","v21c3",
                             "v21c4","x","v31c1","v31c2","v31c3","v31c4","x")
            col_name<-substr(profile,14,18)
            col_index<-which(chergach_cols==col_name)
            setwd("D:\\profiles_171023")
            expt_profile<-substr(profile,14,31)
            expt_current<-scan(expt_profile)
            expt_max_index<-which.max(expt_current)
            expt_max_time <- expt_max_index*0.004    
            cabmod_max_index<-which.max(temperatures_chergach[,col_index])
            cabmod_max_time<-times_chergach[cabmod_max_index,col_index]
            
        } else if(meteorite=='_allende') { # i.e. allende
            sizebin=substr(profile,12,12) 
            velocity=substr(profile,9,10)   
            allende_cols<-c("x","v14c1","v14c2","v14c3","v14c4","x","v17c1","v17c2","v17c3","v17c4","x","v21c1","v21c2","v21c3",
                            "v21c4","x","v31c1","v31c2","v31c3","v31c4","x")
            col_name<-substr(profile,8,12)
            col_index<-which(allende_cols==col_name)
            setwd("D:\\profiles_171011")
            expt_profiles<-list.files(pattern="*.txt")
            expt_profile<-expt_profiles[grep(col_name,expt_profiles)]
            expt_current<-scan(expt_profile)
            expt_max_index<-which.max(expt_current)
            expt_max_time <- expt_max_index*0.004    
            cabmod_max_index<-which.max(temperatures_allende[,col_index])
            cabmod_max_time<-times_allende[cabmod_max_index,col_index]
        }
        
        if(length(metal2)>2500){ # i.e. is a slow ramp
            integ_m2[j] <- sum(metal2[500:2250]) - sum(metal2_bkgnd[500:2250])
            cumulative<-rep(0,1751)
            bkgnd.cumulative<-rep(0,1751)
            for(k in 1:1751){
                cumulative[k]<-sum(metal2[500:k+499])
                bkgnd.cumulative[k]<-sum(metal2_bkgnd[500:k+499])
            }    
            cumulative<-cumulative-bkgnd.cumulative
            centroid_index[j]<-which.min(abs(cumulative-max(cumulative)*percent_integrated/100))+500
            integ_na[j] <- sum(sodium[20:90]) - sum(sodium_bkgnd[20:90])
        } else { # assumed to be an 8 second atmospheric profile
            hot_points_m2<-which(measured_T_original[200:1900]>1500)+200
            hot_points_na<-which(measured_T[8:76]>1500)+8
            if(max(measured_T[8:76])<1500){
                hot_points_m2<-which(measured_T_original[200:1900]>1400)+200
                hot_points_na<-which(measured_T[8:76]>1400)+8           
            }
            num_hot_points_m2<-length(hot_points_m2)
            cumulative<-rep(0,num_hot_points_m2)
            bkgnd.cumulative<-rep(0,num_hot_points_m2)
            for(k in 1:num_hot_points_m2){
                cumulative[k]<-sum(metal2[hot_points_m2[1:k]])
                bkgnd.cumulative[k]<-sum(metal2_bkgnd[hot_points_m2[1:k]])
            }  
            cumulative<-cumulative-bkgnd.cumulative
            centroid_index[j]<-hot_points_m2[which.min(abs(cumulative-max(cumulative)*percent_integrated/100))]
            integ_m2[j] <- sum(metal2[hot_points_m2]) - sum(metal2_bkgnd[hot_points_m2])
            integ_na[j] <- sum(sodium[hot_points_na]) - sum(sodium_bkgnd[hot_points_na])
        }
        
        centroid_time[j]<-time_m2[centroid_index[j]]
        centroid_temp[j] <- measured_T_original[centroid_index[j]]
        
        if(meteorite=='chergach'){
            centroid_time_cabmod[j] <- centroid_time[j] - expt_max_time + cabmod_max_time
            
            centroid_cabmod_index[j]<- which.min(abs(times_chergach[,col_index]-centroid_time_cabmod[j]))
            centroid_altitude[j]<-altitude[centroid_cabmod_index[j]]
        }else if(meteorite=='_allende'){
            centroid_time_cabmod[j] <- centroid_time[j] - expt_max_time + cabmod_max_time
            
            centroid_cabmod_index[j]<- which.min(abs(times_allende[,col_index]-centroid_time_cabmod[j]))
            centroid_altitude[j]<-altitude[centroid_cabmod_index[j]]
        }
        
        
    }
}

data_all<-cbind(integ_m2,centroid_temp,centroid_index,centroid_time,
                centroid_time_cabmod,
                centroid_altitude,
                centroid_cabmod_index)
setwd("D:\\Niall")
fileout<- paste("M052_percent_integrated_",percent_integrated,"_",curr_dir,".txt",sep='')
write.table(data_all,fileout,sep="\t") 
